import 'package:flutter_bloc/flutter_bloc.dart';
import 'package:syncrow_web/pages/spaces_management/all_spaces/model/selected_product_model.dart';
import 'package:syncrow_web/pages/spaces_management/add_device_type/bloc/add_device_type_model_event.dart';

class AddDeviceTypeBloc
    extends Bloc<AddDeviceTypeEvent, List<SelectedProduct>> {
  AddDeviceTypeBloc(List<SelectedProduct> initialProducts)
      : super(initialProducts) {
    on<UpdateProductCountEvent>(_onUpdateProductCount);
  }

  void _onUpdateProductCount(
      UpdateProductCountEvent event, Emitter<List<SelectedProduct>> emit) {
    final existingProduct = state.firstWhere(
      (p) => p.productId == event.productId,
      orElse: () => SelectedProduct(productId: event.productId, count: 0,productName: event.productName,product: event.product ),
    );

    if (event.count > 0) {
      if (!state.contains(existingProduct)) {
        emit([
          ...state,
          SelectedProduct(productId: event.productId, count: event.count, productName: event.productName, product: event.product)
        ]);
      } else {
        final updatedList = state.map((p) {
          if (p.productId == event.productId) {
            return SelectedProduct(productId: p.productId, count: event.count, productName: p.productName,product: p.product);
          }
          return p;
        }).toList();
        emit(updatedList);
      }
    } else {
      emit(state.where((p) => p.productId != event.productId).toList());
    }
  }
}
