import 'package:flutter/material.dart';
import 'package:syncrow_web/utils/color_manager.dart';

class ButtonContentWidget extends StatelessWidget {
  final IconData icon;
  final String label;

  const ButtonContentWidget({
    Key? key,
    required this.icon,
    required this.label,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    final screenWidth = MediaQuery.of(context).size.width;

    return SizedBox(
      width: screenWidth * 0.25,
      child: Container(
        decoration: BoxDecoration(
          color: ColorsManager.textFieldGreyColor,
          border: Border.all(
            color: ColorsManager.neutralGray,
            width: 3.0,
          ),
          borderRadius: BorderRadius.circular(20),
        ),
        child: Padding(
          padding: const EdgeInsets.symmetric(vertical: 10.0, horizontal: 16.0),
          child: Row(
            children: [
              Icon(
                icon,
                color: ColorsManager.spaceColor,
              ),
              const SizedBox(width: 10),
              Expanded(
                child: Text(
                  label,
                  style: const TextStyle(
                    color: ColorsManager.blackColor,
                    fontSize: 16,
                  ),
                ),
              ),
            ],
          ),
        ),
      ),
    );
  }
}
